/*
 * 公告消息已读记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgPlacardReadController : BaseController
    {
        public MsgPlacardReadController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 公告消息已读记录列表

        /// <summary>
        /// 根据条件查询公告消息已读记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgPlacardRead data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "UserId:\"" + data.UserId + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询公告消息已读记录列表

        /// <summary>
        /// 公告消息已读记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgPlacardRead data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("UserId", "2"); //用户ID

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgPlacardRead", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["PlacardId"] = RelationClass.GetMsgPlacardInfo(int.Parse(dic["PlacardId"].ToString()));
dic["ReadFlagName"] = dic["ReadFlag"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加公告消息已读记录

        /// <summary>
        /// 增加或修改公告消息已读记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加公告消息已读记录

        /// <summary>
        /// 增加或修改公告消息已读记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgPlacardRead data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("PlacardId", data.PlacardId); //公告
Fields.Add("UserId", data.UserId); //用户ID
Fields.Add("ReadFlag", data.ReadFlag); //已读标记
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("MsgPlacardRead", Fields, 0);
            AddSysLog(data.Id.ToString(), "MsgPlacardRead", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改公告消息已读记录

        /// <summary>
        /// 增加或修改公告消息已读记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            MsgPlacardRead editData = bsdb.MsgPlacardRead.FirstOrDefault(m => m.Id == Id) ?? new MsgPlacardRead();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改公告消息已读记录

        /// <summary>
        /// 增加或修改公告消息已读记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgPlacardRead data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("PlacardId", data.PlacardId); //公告
Fields.Add("UserId", data.UserId); //用户ID
Fields.Add("ReadFlag", data.ReadFlag); //已读标记
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPlacardRead", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MsgPlacardRead","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除公告消息已读记录信息

        /// <summary>
        /// 删除公告消息已读记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPlacardRead","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPlacardRead", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPlacardRead","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPlacardRead", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPlacardRead","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPlacardRead", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("MsgPlacardRead", Sort, Id);
            
            AddSysLog(Id.ToString(), "MsgPlacardRead", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.MsgPlacardRead.Add(new MsgPlacardRead()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "MsgPlacardRead", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgPlacardRead data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("UserId", "2"); //用户ID

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgPlacardRead", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["PlacardId"] = RelationClass.GetMsgPlacardInfo(int.Parse(dic["PlacardId"].ToString()));
dic["ReadFlagName"] = dic["ReadFlag"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgPlacardRead", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
